LeetCode_数据结构_三数之和

这篇博客介绍了如何解决LeetCode上的三数之和问题,提供了两种不同的Java实现方法。第一种方法使用三层循环并结合双指针,第二种方法在第二层循环后直接用第三个指针寻找目标值,提高了效率。两种解法都确保了结果中不包含重复的三元组。
摘要由CSDN通过智能技术生成

三数之和

给你一个包含 n 个整数的数组 nums,判断 nums 中是否存在三个元素 a,b,c ,使得 a + b + c = 0 ?请你找出所有和为 0 且不重复的三元组。

注意:答案中不可以包含重复的三元组。

示例 1:

输入:nums = [-1,0,1,2,-1,-4]
输出:[[-1,-1,2],[-1,0,1]]
示例 2:

输入:nums = []
输出:[]
示例 3:

输入:nums = [0]
输出:[]

(上述题目来源于LeetCode)

解法一
class Solution {
    public List<List<Integer>> threeSum(int[] nums) {
        /*排序 + 三层循环
        首先将数组排序,然后使用三层循环
        在使用三层循环的过程中,运用到了双指针的方法,即固定第一个数,
        将第二个数和第三个数的下标作为双指针
        */
        //定义结果集
        List<List<Integer>> result = new ArrayList<List<Integer>>();
        //排序
        Arrays.sort(nums);
        //第一层循环,找第一个数
        for(int first = 0;first < nums.length;first++){
            //确定第一个数不是上次已经枚举的数
            if(first > 0 && nums[first] == nums[first - 1]){
                continue;
            }
            //确定第一个数,由于三个数相加等于0,所以另外两个数之和为第一个的相反数
            int target = -nums[first];
            //第二层循环,找第二个数,second为左指针,从左往右
            for(int second = first + 1;second < nums.length;second++){
                //确定第二个数不是上次已经枚举的数
               if(second > first + 1 && nums[second] == nums[second - 1]){
                   continue;
               }
               //第三层循环,找第三个数,third为右指针,从右往左
                for(int third = nums.length - 1;second < third;third--){
                    //如果另外两个数的和已经小于target,再往下的和只会越来越小
                    //所以直接跳出循环
                   if(nums[second] + nums[third] < target){
                        break;
                    }
                    //确定第三个数不是已经枚举的数
                    if(third < nums.length - 1 && nums[third] == nums[third + 1]){
                        continue;
                    }
                    //如果找到另外两个数的和为target
                   if(nums[second] + nums[third] == target){
                    List<Integer> res = new ArrayList<Integer>();
                    res.add(nums[first]);
                    res.add(nums[second]);
                    res.add(nums[third]);
                    result.add(res);
                }
                }
            }
        }
        return result;
    }
}
解法二
class Solution {
    public List<List<Integer>> threeSum(int[] nums) {
        /*排序 + 三层循环
        首先将数组排序,然后使用三层循环
        在使用三层循环的过程中,运用到了双指针的方法,即固定第一个数,
        将第二个数和第三个数的下标作为双指针
        */
        //定义结果集
        List<List<Integer>> result = new ArrayList<List<Integer>>();
        //排序
        Arrays.sort(nums);
        //第一层循环,找第一个数
        for(int first = 0;first < nums.length;first++){
            //确定第一个数不是上次已经枚举的数
            if(first > 0 && nums[first] == nums[first - 1]){
                continue;
            }
            //确定第一个数,由于三个数相加等于0,所以另外两个数之和为第一个的相反数
            int target = -nums[first];
            int third = nums.length - 1;
            //第二层循环,找第二个数,second为左指针,从左往右
            for(int second = first + 1;second < nums.length;second++){
                //确定第二个数不是上次已经枚举的数
               if(second > first + 1 && nums[second] == nums[second - 1]){
                   continue;
               }
               //第三层循环,由于third--在while循环中出现,所以在前两个数都确定的情况下,
               //第三个数只会取最右边符合要求的数,不用再判断第三个数是否重复枚举
               while(second < third && nums[second] + nums[third] > target){
                   third--;
               }
               if(second == third){
                   break;
               }
                    //如果找到另外两个数的和为target
                   if(nums[second] + nums[third] == target){
                    List<Integer> res = new ArrayList<Integer>();
                    res.add(nums[first]);
                    res.add(nums[second]);
                    res.add(nums[third]);
                    result.add(res);
                }
                
            }
        }
        return result;
    }
}
评论
添加红包

请填写红包祝福语或标题

红包个数最小为10个

红包金额最低5元

当前余额3.43前往充值 >
需支付:10.00
成就一亿技术人!
领取后你会自动成为博主和红包主的粉丝 规则
hope_wisdom
发出的红包
实付
使用余额支付
点击重新获取
扫码支付
钱包余额 0

抵扣说明:

1.余额是钱包充值的虚拟货币,按照1:1的比例进行支付金额的抵扣。
2.余额无法直接购买下载,可以购买VIP、付费专栏及课程。

余额充值